<?php
/**
* AccordionMenuApplestyle plugin
* This plugin allows you to insert the Accordion Menu Apple style
* with the tags {Accordion_Menu_Apple_style} ... {/Accordion_Menu_Apple_style}.
* Author: kksou
* Copyright (C) 2006-2008. kksou.com. All Rights Reserved
* License: GNU/GPL http://www.gnu.org/copyleft/gpl.html
* Website: http://www.kksou.com/php-gtk2/Joomla-Gadgets/
* v1.0 September 27, 2008
*/

#defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class AccordionMenu_base {

	function process(&$row, $matches) {
		$this->menu_height = 100;
		if (preg_match('/^(\d+)/', $matches[1], $matches2)) {
			$this->menu_height = $matches2[1];
		}
		$this->float = '';
		if (preg_match('/float:(left|right)(\d*)/', $matches[1], $matches2)) {
			$this->float = $matches2[1];
			$this->float_padding = $matches2[2];
		}
		$str = $this->fix_str2($matches[3]);

		if (preg_match('/revealtype:(click|mouseover)/', $matches[1], $matches2)) {
			$this->revealtype = $matches2[1];
		}

		$this->css = 'AccordionMenuApplestyle.css';
		if (preg_match('/css:([^\s]*)/', $matches[1], $matches2)) {
			$this->css = $matches2[1];
		}

		if (preg_match('/width:(\d+)/', $matches[1], $matches2)) {
			if ($matches2[1]!='') $this->menu_width = $matches2[1];
		}

		$this->setup_css();
		$str2 = $this->process_menu($str);
		#print "<link rel=\"stylesheet\" href=\"$this->base_url2/AccordionMenuApplestyle.css\" type=\"text/css\" />";
		$row->text = str_replace($matches[0], $this->menu.$str2, $row->text);
	}

	function process_menu($str) {
		$lines = explode("\n", $str);
		$i = 0;
		$submenu_on = 0;
		$str2 = '';
		$regexp_url = '%(-?)\s*\[url=(.*?)\s?(1?)\](.*?)\[\/url\]%s';
		foreach($lines as $line) {
			if (trim($line)=='') continue;

			$level = 1;
			if (preg_match($regexp_url, $line, $matches)) {
				$target = '';
				if ($matches[3]) $target = ' target=_blank';
				$a = "<a href=\"$matches[2]\"$target>$matches[4]</a>";
				if ($matches[1]!='') $level = 2;
			} else {
				if (!preg_match('/^- /', $line)) {
					$a = "<span class=\"level1\">$line</span>";
					if ($line == strip_tags($line)) $a = "<em><span class=\"level1\">$line</span></em>";
				} else {
					$level = 2;
					$a = substr($line,2);
					if (!preg_match('/img/', $a)) $a = "    ".$a;

				}
			}

			if ($level==1) {
				if ($submenu_on) {
					$str2 .= '    </div>';
					$submenu_on = 0;
				}
				$str2 .= "<div class=\"silverheader\">$a</div>";
			} elseif ($level==2) {
				if (!$submenu_on) {
					$str2 .=  '    <div class="submenu">';
					$submenu_on = 1;
				}
				$str2 .= "<span class=\"level2\">$a</span><br />";
			}

			++$i;
		}

		if ($submenu_on) {
			$str2 .= '    </div>';
			$submenu_on = 0;
		}

		if (!isset($this->z)) $this->z = '';
		if (preg_match('/(left|right)/', $this->float)) {
			$padding = '';
			if ($this->float=='right') $padding = "padding-left:{$this->float_padding}px;";
			elseif ($this->float=='left') $padding = "padding-right:{$this->float_padding}px;";
			#$str2 = "<div style=\"float:$this->float;$padding\"><div class=\"applemenu\">".$str2.'</div></div>';

			$str2 = "<div class=\"b1\" style=\"float:$this->float;$padding\"><div class=\"applemenu\">".$str2."</div>$this->z</div>";
		} else {
			#$str2 = '<div class="applemenu">'.$str2.'</div>';
			$str2 = "<table cellpadding=\"0\" cellspacing=\"0\" border=0><tr><td><div class=\"applemenu\">".$str2."</div></td></tr><tr><td>$this->z</td></tr></table>";
		}

		return $str2;
	}

	function process_menu_org_081003($str) {
		$lines = explode("\n", $str);
		$i = 0;
		$submenu_on = 0;
		$str2 = '';
		$regexp = '%(-?)\s*\[url=(.*?)\s?(1?)\](.*?)\[\/url\]%s';
		foreach($lines as $line) {
			if (trim($line)=='') continue;

			if (preg_match($regexp, $line, $matches)) {
				$target = '';
				if ($matches[3]) $target = ' target=_blank';
				if ($matches[1]=='') {
					if ($submenu_on) {
						$str2 .= '    </div>';
						$submenu_on = 0;
					}
					$str2 .= "<div class=\"silverheader\"><a href=\"$matches[2]\"$target>$matches[4]</a></div>";
				} else {
					if (!$submenu_on) {
						$str2 .=  '    <div class="submenu">';
						$submenu_on = 1;
					}
					$str2 .= "    <a href=\"$matches[2]\"$target>$matches[4]</a><br />";
				}
			} else {
				if ($matches[1]=='') {
					if ($submenu_on) {
						$str2 .= '    </div>';
						$submenu_on = 0;
					}
					$str2 .= "<div class=\"silverheader\"><em>$line</em></div>";
				}
			}

			++$i;
		}

		if ($submenu_on) {
			$str2 .= '    </div>';
			$submenu_on = 0;
		}

		if (preg_match('/(left|right)/', $this->float)) {
			$padding = '';
			if ($this->float=='right') $padding = "padding-left:{$this->float_padding}px;";
			elseif ($this->float=='left') $padding = "padding-right:{$this->float_padding}px;";
			$str2 = "<div style=\"float:$this->float;$padding\"><div class=\"applemenu\">".$str2.'</div></div>';
		} else {
			$str2 = '<div class="applemenu">'.$str2.'</div>';
		}

		return $str2;
	}

	function process_menu_org($str) {
		#if (preg_match_all('/(-?)\s*\[url=(.*?)\](.*?)\[\/url\]/', $str, $matches_array, PREG_SET_ORDER)) {

		$regexp = '%(-?)\s*\[url=(.*?)\s?(1?)\](.*?)\[\/url\]%s';
		if (preg_match_all($regexp, $str, $matches_array, PREG_SET_ORDER)) {

			$i = 0;
			$submenu_on = 0;
			$str2 = '';
			foreach($matches_array as $matches) {
				$target = '';
				if ($matches[3]) $target = ' target=_blank';
				if ($matches[1]=='') {
					if ($submenu_on) {
						$str2 .= '    </div>';
						$submenu_on = 0;
					}
					$str2 .= "<div class=\"silverheader\"><a href=\"$matches[2]\"$target>$matches[4]</a></div>";
				} else {
					if (!$submenu_on) {
						$str2 .=  '    <div class="submenu">';
						$submenu_on = 1;
					}
					$str2 .= "    <a href=\"$matches[2]\"$target>$matches[4]</a><br />";
				}
				++$i;
			}

			if ($submenu_on) {
				$str2 .= '    </div>';
				$submenu_on = 0;
			}

			if (preg_match('/(left|right)/', $this->float)) {
				$padding = '';
				if ($this->float=='right') $padding = "padding-left:{$this->float_padding}px;";
				elseif ($this->float=='left') $padding = "padding-right:{$this->float_padding}px;";
				$str2 = "<div style=\"float:$this->float;$padding\"><div class=\"applemenu\">".$str2.'</div></div>';
			} else {
				$str2 = '<div class="applemenu">'.$str2.'</div>';
			}
		}

		return $str2;
	}

	function fix_str($str) {
		$str = preg_replace(array('%&lt;\?php(\s|&nbsp;|<br\s/>|<br>|<p>|</p>)%s', '/\?&gt;/s', '/-&gt;/'), array('<?php ', '?>', '->'), $str);
		return $str;
	}

	function fix_str2($str) {
		$str = str_replace('<br>', "\n", $str);
		$str = str_replace('<br />', "\n", $str);
		$str = str_replace('<p>', "\n", $str);
		$str = str_replace('</p>', "\n", $str);
		$str = str_replace('&#39;', "'", $str);
		$str = str_replace('&quot;', '"', $str);
		$str = str_replace('&lt;', '<', $str);
		$str = str_replace('&gt;', '>', $str);
		$str = str_replace('&amp;', '&', $str);
		$str = str_replace('&nbsp;', ' ', $str);
		$str = str_replace('&#160;', "\t", $str);
		$str = str_replace("\r", "", $str);
		$str = str_replace("\n\n", "\n", $str);
		$str = str_replace(chr(hexdec('C2')).chr(hexdec('A0')), '', $str);
		return $str;
	}

	function get_param($module, $ver) {
		if ($ver=='1.0') {
			$this->get_param10($module);
		} elseif ($ver=='1.5') {
			$this->get_param15($module);
		}

		if ($this->revealtype=='') $this->revealtype = 'mouseover';
		if ($this->menu_width<=10) $this->menu_width = 170;
	}

	function get_param10($module) {
		global $database, $_MAMBOTS;

		if ( !isset($_MAMBOTS->_content_mambot_params[$module]) ) {
			$query = "SELECT params"
			. "\n FROM #__mambots"
			. "\n WHERE element = '$module'"
			. "\n AND folder = 'content'"
			;
			$database->setQuery( $query );
			$database->loadObject($mambot);
			$_MAMBOTS->_content_mambot_params[$module] = $mambot;
		}

		$mambot = $_MAMBOTS->_content_mambot_params[$module];
		$botParams = new mosParameters( $mambot->params );
		$this->revealtype = $botParams->def( 'revealtype', 'mouseover' );
		$this->menu_width = $botParams->def( 'width', '170' );

		global $mosConfig_live_site;
		$this->base_url = $mosConfig_live_site."/mambots/content";
		$this->base_url2 = $mosConfig_live_site."/mambots/content/ddaccordion";
	}

	function get_param15($module) {
		$plugin =& JPluginHelper::getPlugin('content', $module);
		$pluginParams = new JParameter( $plugin->params );
		$this->revealtype = $pluginParams->get('revealtype');
		$this->menu_width = $pluginParams->get('width');

		$mosConfig_live_site = JURI::base();
		$this->base_url = $mosConfig_live_site."plugins/content";
		$this->base_url2 = $mosConfig_live_site."plugins/content/ddaccordion";
	}
}

?>
